'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = createPickerInput;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function createPickerInput(picker) {
  var PickerInput = function (_Component) {
    _inherits(PickerInput, _Component);

    function PickerInput(props) {
      _classCallCheck(this, PickerInput);

      var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(PickerInput).call(this, props));

      _this.state = { isPickerHidden: true };
      return _this;
    }

    _createClass(PickerInput, [{
      key: 'togglePicker',
      value: function togglePicker() {
        var isPickerHidden = this.state.isPickerHidden;

        this.setState({ isPickerHidden: !isPickerHidden });
      }
    }, {
      key: 'handlePickerChange',
      value: function handlePickerChange(value, pickerIndex, pickersCount) {
        var onChange = this.props.onChange;

        onChange(value);
        if (pickerIndex === pickersCount - 1) {
          this.togglePicker();
        }
      }
    }, {
      key: 'clearValue',
      value: function clearValue() {
        var onChange = this.props.onChange;
        // we'll pass an empty string instead null to prevent problems
        // with third-party form libraries

        onChange('');
        this.togglePicker();
      }
    }, {
      key: 'render',
      value: function render() {
        var _this2 = this;

        var _props = this.props;
        var value = _props.value;
        var renderInput = _props.renderInput;
        var renderValue = _props.renderValue;
        var onClick = _props.onClick;

        var other = _objectWithoutProperties(_props, ['value', 'renderInput', 'renderValue', 'onClick']);

        var isPickerHidden = this.state.isPickerHidden;

        var input = _react2.default.createElement('input', _extends({}, other, {
          value: renderValue(value),
          readOnly: true
        }));
        var clonedPicker = (0, _react.cloneElement)(picker, {
          value: value,
          style: _extends({
            boxShadow: '2px 2px 5px #ddd',
            maxHeight: 265,
            overflow: 'auto',
            position: 'absolute',
            top: this.inputWrapper && this.inputWrapper.offsetHeight + 1,
            left: 0,
            zIndex: 1
          }, picker.props.style),
          onChange: this.handlePickerChange.bind(this)
        });
        return _react2.default.createElement(
          'div',
          { style: { position: 'relative' } },
          _react2.default.createElement(
            'div',
            { ref: function ref(inputWrapper) {
                return _this2.inputWrapper = inputWrapper;
              } },
            renderInput(input, value, isPickerHidden, this.togglePicker.bind(this), this.clearValue.bind(this))
          ),
          !isPickerHidden && clonedPicker
        );
      }
    }]);

    return PickerInput;
  }(_react.Component);

  PickerInput.propTypes = {
    className: _react.PropTypes.string,
    value: _react.PropTypes.string,
    renderInput: _react.PropTypes.func,
    renderValue: _react.PropTypes.func,
    onChange: _react.PropTypes.func
  };
  PickerInput.defaultProps = {
    className: 'smalldots-react-picker-input form-control',
    renderInput: function renderInput(input, value, isPickerHidden, togglePicker, clearValue) {
      return _react2.default.createElement(
        'div',
        { className: 'input-group' },
        input,
        _react2.default.createElement(
          'span',
          { className: 'input-group-btn' },
          !isPickerHidden && _react2.default.createElement(
            'button',
            {
              className: 'btn btn-default',
              type: 'button',
              disabled: input.props.disabled,
              onClick: clearValue
            },
            _react2.default.createElement('span', { className: 'fa fa-times' })
          ),
          _react2.default.createElement(
            'button',
            {
              className: 'btn btn-default',
              type: 'button',
              disabled: input.props.disabled,
              onClick: togglePicker
            },
            _react2.default.createElement('span', { className: 'fa fa-' + (isPickerHidden ? 'calendar' : 'check') })
          )
        )
      );
    },
    renderValue: function renderValue(value) {
      return value && (0, _moment2.default)(value).format('LL');
    }
  };
  return PickerInput;
}
